-- 星魂试炼-章节
Lua_StarTrialChapterPanel = class("Lua_StarTrialChapterPanel", Lua_DisplayObject);
function Lua_StarTrialChapterPanel:ctor(go)
	self:superCall("ctor", go);
end

function Lua_StarTrialChapterPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.maskBg = UICreate.createImage(self.content, "/images/starTrial/xui_xhd_bj_003.png", 0, 0, 0, 0);
	self.maskBg.anchor = Lua_WindowUtil.getAnchor(1);
	self.maskBg.pivotValue = 1;
	self.maskBg:setLocation(0, 360 - self.adaptHeight);

	self.dragContainer = Lua_DragContainer.new(self.content, 661, 700 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragContainer:setSiblingIndex(0);
	self.dragContainer:setLocation(0, 250);
	self.dragContainer:setCellSpacing(0, 10);

	self:addLuaEvent("UPDATE_STARTRIAL_CHAPTER_INFO", self, self.updateChapterInfo);
	Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sChapterInfo();
end

function Lua_StarTrialChapterPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.dragContainer:setContentRect(661, 700 + adaptHeight);
	self.maskBg:setLocation(0, 360 - adaptHeight);
end

function Lua_StarTrialChapterPanel:updateChapterInfo()
	local arr = DataCenter.starTrialUitl.getChapterArr;
	local index, canDraw;
	self.dragContainer:clearList();
	for i = 1, arr:getSize() do
		if not canDraw and arr[i].canDraw then
			canDraw = true;
			index = i;
		end
		if not canDraw and arr[i].state == 1 then
			index = i;
		end
		self.dragContainer:addSubContainer(Lua_StarTrialChapterViewItem, arr[i]);
	end
	self.dragContainer:updateChildPos();
	self.dragContainer:moveToIndex(index or 1, true, false);
end

function Lua_StarTrialChapterPanel:dispose()
	if self.maskBg ~= nil then
		self.maskBg:dispose();
		self.maskBg = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end










Lua_StarTrialChapterViewItem = class("Lua_StarTrialChapterViewItem", Lua_DragContainerItem);
function Lua_StarTrialChapterViewItem:ctor(p)
	self:superCall("ctor", p, "StarTrialChapterViewItem_skin");
end

function Lua_StarTrialChapterViewItem:buildShowItem()
	self:superCall("buildShowItem");

	self.offsetHeight = 120;

	self.chapterNum = Lua_NumberImage.new(self.content);
	self.chapterNum.pivot = 1;
	self.chapterNum.numAtlas = "number";
	self.chapterNum.preStr = "xui_xhd_number_";
	self.chapterNum.numOffsetX = -20;

	self.boxIcon:addClickFuntion(self, self.onChapterInfoClick);
end

function Lua_StarTrialChapterViewItem:setData(data)
	self.data = data;

	local offsetY = data.id == DataCenter.starTrialUitl.getChapterArr:getSize() and self.offsetHeight / 2 or 0;
	self.bg:setLocation(0, 0 + offsetY);
	self.boxIcon:setLocation(193, 10 + offsetY);
	self.chapterIconOne:setLocation(-238, -1 + offsetY);
	LuaUtil.setObjPos(self.starObj, 0, 4 + offsetY, 0);
	LuaUtil.setObjPos(self.limitObj, 0, 4 + offsetY, 0);

	local chapternum = tonumber(data.id);
	self.chapterNum.num = data.id;
	self.chapterNum:setLocation(-221, -3 + offsetY);
	self.chapterIconTwo:setLocation(-206 + self.chapterNum.totalWidth, -1 + offsetY);

	if data.state == 0 then
		self.starNumBg:SetDimensions(228, 65);
		self.starNumBg:setLocation(178, -32 + offsetY);

		local prevVo = DataCenter.starTrialUitl:getChapterVo(data.prev_chapter);
		local str = spliceIconStr("starTrial_altas", "xui_xhd_label_002", 31, 30);
		self.tipTxt.text = LanUtil.formateStr(201619, data.limit_lvl, prevVo.remark, data.unlock_star, str);
	else
		self.starNumBg:SetDimensions(228, 52);
		self.starNumBg:setLocation(178, -37 + offsetY);
	end
	self.starNumTxt.text = data.starNum .. "/" .. data.total_star;
	self.progressBar:setMaxValue(data.total_star);
	self.progressBar:setValue(data.starNum);
	self.progressBar:setEnable(not data.isMaxStar);

	self.bg:setGray(data.state == 0);
	self.boxIcon:setGray(data.state == 0);
	self.limitObj:SetActive(data.state == 0);
	self.starObj:SetActive(data.state ~= 0);
	self.collectSignIcon:setEnable(data.isMaxStar);
	self:showRedDot(data.state == 1 and data.canDraw);
end

function Lua_StarTrialChapterViewItem:showRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(290, 60);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_StarTrialChapterViewItem:onPressClick()
	self:onChapterViewSureFun(1);
end

function Lua_StarTrialChapterViewItem:onChapterInfoClick()
	self:onChapterViewSureFun(2);
end

function Lua_StarTrialChapterViewItem:onChapterViewSureFun(operateType)
	if self.data.state == 0 then
		OperateAlert.showLangValue(201605);
		return;
	end
	if operateType == 1 then
		Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_CHAPTER_SELECT", {chapter = self.data.id});
	elseif operateType == 2 then
		Lua_WindowUtil.openWin("Lua_StarTrialStarRewardWindow", Lua_WinParam.ACTION_OPEN, self.data.id);
	end
end

function Lua_StarTrialChapterViewItem:getWidth()
	return self.bg.width;
end

function Lua_StarTrialChapterViewItem:getHeight()
	if self.data.id == DataCenter.starTrialUitl.getChapterArr:getSize() then
		return self.bg.height + self.offsetHeight;
	else
		return self.bg.height;
	end
end

function Lua_StarTrialChapterViewItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.chapterNum ~= nil then
		self.chapterNum:dispose();
		self.chapterNum = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end