-- 星魂试炼-扫荡补星
Lua_StarTrialDailyRewardWindow = class("Lua_StarTrialDailyRewardWindow", Lua_Window);
function Lua_StarTrialDailyRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_StarTrialDailyRewardWindow";
	self.skinName = "StarTrialDailyRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_StarTrialDailyRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.showOrHideStateDic = {}; -- 记录章节是处于展开还是收起状态

	local arr = Array();
	arr:add({des = LanUtil.getValue(201626)});
	arr:add({des = LanUtil.getValue(201627)});
	self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.buttonList:setLocation(0, -446);
	self.buttonList:setButtonItem(191, 58);
	self.buttonList:setButtonCell(Lua_StarTrialDailyButtonItem);
	self.buttonList:setClickCallBack(self, self.onButtonListClick);
	self.buttonList:setData(arr);

	self:addLuaEvent("UPDATE_STARTRIAL_DAILYREWARD", self, self.updateSweepInfo);
	self:addLuaEvent("ON_CHAPTER_ITEMCLICK", self, self.updateChapterList);
	self:addLuaEvent("UPDATE_STARTRIAL_NOMAXCHAPTER_DATA", self, self.showWinInfo);
	Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sNoMaxStarChapterInfo();
end

function Lua_StarTrialDailyRewardWindow:showWinInfo(chapterList)
	if chapterList == nil then
		return;
	end
	self.chapterList = chapterList;
	self.buttonList:setSelected(1);
end

function Lua_StarTrialDailyRewardWindow:onButtonListClick(showIdx)
	if showIdx == 1 then
		self.tipsTxt:setLangValue(201624);
		self:updateSweepInfo();
	elseif showIdx == 2 then
		self.tipsTxt:setLangValue(201625);
		self:showChapterList();
	end
end

function Lua_StarTrialDailyRewardWindow:updateSweepInfo()
	if self.dragContainer ~= nil then
		self.dragContainer:setEnable(false);
	end
	
	local info = DataCenter.starTrialUitl:getSweepInfoById(DataCenter.starTrialData.curSweepId);
	if self.sweepItem == nil then
		self.sweepItem = Lua_StarTrialDailyRewardItem.new(self.content);
		self.sweepItem:setLocation(0, 148);
	end
	self.sweepItem:setEnable(true);
	self.sweepItem:setData(info.reward);
end

function Lua_StarTrialDailyRewardWindow:showChapterList()
	self.sweepItem:setEnable(false);

	if self.dragContainer == nil then
		self.dragContainer = Lua_DragContainer.new(self.content, 624, 604, Lua_AxisDefine.Vertical);
		self.dragContainer:setCellPivot(1);
		self.dragContainer:setLocation(0, -71, 0);

		self:updateChapterList();
	end
	self.dragContainer:setEnable(true);
end

function Lua_StarTrialDailyRewardWindow:updateChapterList(data)
	local chapter;
	for i = 1, #self.chapterList do
		chapter = self.chapterList[i].chapter;
		self.showOrHideStateDic[chapter] = false;

		if data and data.chapter == chapter then
			self.showOrHideStateDic[chapter] = data.isOpen;
		end
	end

	self.dragContainer:clearList();
	local data;
	for i = 1, #self.chapterList do
		data = {chapterData = self.chapterList[i], isOpen = self.showOrHideStateDic[self.chapterList[i].chapter]};
		self.dragContainer:addSubContainer(Lua_StarTrialChapterItem, data, false);
	end
	self.dragContainer:updateChildPos();

	-- 更新显示位置
	self.recordHeight = self.recordHeight or self.dragContainer.subRectH;

	local changeHeight = self.dragContainer.subRectH - self.recordHeight;
	local pos = self.dragContainer.curSubPos - changeHeight / 2;
	if pos < self.dragContainer.subMinPos then
		pos = self.dragContainer.subMinPos;
	elseif pos > self.dragContainer.subMaxPox then
		pos = self.dragContainer.subMaxPox;
	end
	self.dragContainer:setSubPosition(pos);

	self.recordHeight = self.dragContainer.subRectH;
end

function Lua_StarTrialDailyRewardWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.buttonList ~= nil then
		self.buttonList:dispose();
		self.buttonList = nil;
	end
	if self.sweepItem ~= nil then
		self.sweepItem:dispose();
		self.sweepItem = nil;
	end
	self.chapterList = nil;
	self.showOrHideStateDic = nil;
	self:superCall("dispose");
end










Lua_StarTrialDailyButtonItem = class("Lua_StarTrialDailyButtonItem", Lua_ButtonCell)
function Lua_StarTrialDailyButtonItem:ctor(p)
	self:superCall("ctor", p, "StarTrialDailyButtonItem_skin");
end

function Lua_StarTrialDailyButtonItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg.alpha = 0.01;
	self.bg:addClickFuntion(self, self.onPressClick);
end

function Lua_StarTrialDailyButtonItem:setData(data)
	self.titleTxt.text = data.des;
end

function Lua_StarTrialDailyButtonItem:setSelected(index)
	if index == self.index then
		self.bg:setAltas("common_altas_1", "xui_common_button_006_n");
		self.bg.alpha = 1;
		self.titleTxt.colorStr = Lua_ColorDefine.transColorStr("8F5123");
	else
		self.bg:setAltas("common_altas_1", "xui_common_button_007_n");
		self.bg.alpha = 0.01;
		self.titleTxt.colorStr = Lua_ColorDefine.transColorStr("594D4D");
	end
end

function Lua_StarTrialDailyButtonItem:dispose()
	self:superCall("dispose");
end










Lua_StarTrialDailyRewardItem = class("Lua_StarTrialDailyRewardItem", Lua_DisplayObject);
function Lua_StarTrialDailyRewardItem:ctor(p)
	self:superCall("ctor", p, "StarTrialDailyRewardItem_skin");
end

function Lua_StarTrialDailyRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_ItemIconList.new(self.content);
	self.rewardList.scaleVal = 0.8;
	self.rewardList.pivot = 1;
	self.rewardList.canClick = true;
	self.rewardList:setLocation(-245, -16, 0);

	self.sweepOneBtn:addClickFuntion(self, self.onSweepBtnClick);
end

function Lua_StarTrialDailyRewardItem:setData(data)
	self.daySweepTimes.text = LanUtil.formateStr(201621, DataCenter.starTrialData.sweepTimes);
	self.rewardList:setArrayData(data);

	local sweepTimes = DataCenter.starTrialData.sweepTimes;
	self.sweepOneBtn:setStyle(sweepTimes > 0 and 1 or 16);
	self.sweepOneBtn:setMouseEnable(sweepTimes > 0);
end

function Lua_StarTrialDailyRewardItem:onSweepBtnClick()
	Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sGetDailyReward();
end

function Lua_StarTrialDailyRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end








Lua_StarTrialChapterItem = class("Lua_StarTrialChapterItem", Lua_DragContainerItem);
function Lua_StarTrialChapterItem:ctor(p)
	self:superCall("ctor", p, "StarTrialChapterItem_skin");
end

function Lua_StarTrialChapterItem:buildShowItem()
	self:superCall("buildShowItem");

	self.offsetHeight = 6;
	self.levelCount = 0;
	self.levelArr = Array();
	self.showSign:addClickFuntion(self, self.showSignClick);
end

function Lua_StarTrialChapterItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local chapterVo = DataCenter.starTrialUitl:getChapterVo(data.chapterData.chapter);
	self.chapterName.text = chapterVo.remark;
	self.starNum.text = chapterVo.starNum.."/"..chapterVo.total_star;

	if data.isOpen then
		local stageList = data.chapterData.stage_star;
		table.sort(stageList, function(a, b) return a.type < b.type; end);
		self.levelCount = #stageList;
		self.showSign:setRot(0, 0, 0);
		
		local arrLen = self.levelArr:getSize();
		local maxLen = self.levelCount > arrLen and self.levelCount or arrLen;
		local item;
		for i = 1, maxLen do
			item = self.levelArr[i];
			if i > self.levelCount then
				if item ~= nil then
					item:setEnable(false);
				end
			else
				if item == nil then
					item = Lua_StarTrialLevelItem.new(self.content);
					item:setRectAnchor(1);
					self.levelArr:add(item);
				end
				item:setEnable(true);
				item:setData(stageList[i]);
				item:setLocation(0, -self.offsetHeight / 2 - self.bg.height - item.bg.height / 2 - (i - 1) * 90);
			end
		end
	else
		self.levelCount = 0;
		self.showSign:setRot(0, 0, 180);
		for i = 1, self.levelArr:getSize() do
			self.levelArr[i]:setEnable(false);
		end
	end
end

function Lua_StarTrialChapterItem:getWidth()
	return 624;
end

function Lua_StarTrialChapterItem:getHeight()
	return self.bg.height + self.offsetHeight + self.levelCount * 90;
end

function Lua_StarTrialChapterItem:showSignClick()
	Lua_MsgUtil.callFunc("ON_CHAPTER_ITEMCLICK", {chapter = self.data.chapterData.chapter, isOpen = not self.data.isOpen});
end

function Lua_StarTrialChapterItem:dispose()
	if self.levelArr ~= nil then
		self.levelArr:dispose();
		self.levelArr:clear();
		self.levelArr = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end










Lua_StarTrialLevelItem = class("Lua_StarTrialLevelItem", Lua_ListCell);
function Lua_StarTrialLevelItem:ctor(p)
	self:superCall("ctor", p, "StarTrialLevelItem_skin");
end

function Lua_StarTrialLevelItem:buildShowItem()
	self:superCall("buildShowItem");

	self.starList = {self.starOne, self.starTwo, self.starThree};
	self.goBtn:addClickFuntion(self, self.onGoBtnClick);
end

function Lua_StarTrialLevelItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local stageVo = DataCenter.starTrialUitl:getStageVo(data.type);
	self.levelNumTxt.text = stageVo.chapter.."-"..stageVo.index;

	for i = 1, #data.map_list do
		if data.map_list[i].value == 0 then
			self.starList[i]:setAltas("starTrial_altas", "xui_xhd_label_010");
		else
			self.starList[i]:setAltas("starTrial_altas", "xui_xhd_label_002");
		end
	end
end

function Lua_StarTrialLevelItem:onGoBtnClick()
	local stageVo = DataCenter.starTrialUitl:getStageVo(self._data.type);
	Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_CHAPTER_SELECT", {chapter = stageVo.chapter, level = stageVo.index});
	Lua_WindowUtil.openWin("Lua_StarTrialDailyRewardWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_StarTrialLevelItem:dispose()
	self.starList = nil;
	self._data = nil;
	self:superCall("dispose");
end