-- 星河殿-战斗预览
checkRequire("Lua_StarTrialStarItem");
Lua_StarTrialLevelInfoItem = class("Lua_StarTrialLevelInfoItem", Lua_DisplayObject);
function Lua_StarTrialLevelInfoItem:ctor(p)
	self:superCall("ctor", p, "StarTrialLevelInfoItem_skin");
end

function Lua_StarTrialLevelInfoItem:buildShowItem()
	self:superCall("buildShowItem");

	self.condIitemArr = Array();

	self.rewardList = Lua_DragList.new(self.content, 198, 86, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_StarTrialLevelRewardItem, 86, 86, 1);
	self.rewardList:setLocation(-249, 0, 0);

	self.challengeBtn:addClickFuntion(self, self.onFightBtnClick);
end

function Lua_StarTrialLevelInfoItem:setData(data)
	self._data = data;

	local dataList = {};
	for i = 1, data.reward:getSize() do
		dataList[i] = {rewardData = data.reward[i], state = data.state, showIcon = i == 1};
	end
	self.rewardList:setArrayData(dataList);

	local arrLen = self.condIitemArr:getSize();
	local dataLen = #data.star_cond;
	local maxLen = dataLen > arrLen and dataLen or arrLen;
	local item;
	for i = 1, maxLen do
		item = self.condIitemArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_StarTrialStarItem.new(self.content);
				self.condIitemArr:add(item);
			end
			item:setEnable(true);
			item:setLocation(24, 32 - (i - 1) * 30, 0);
			item:setData({isNotGet = data.starDic[i], data = data.starCondArr[i]});
		end
	end

	if data.star >= 3 then
		self.passIcon:setEnable(true);
		self.challengeBtn:setEnable(false);
		self.challengeTxt:setEnable(false);
	else
		self.passIcon:setEnable(false);
		self.challengeBtn:setEnable(true);
		self.challengeTxt:setEnable(true);
	end
	self.customsPassNumTxt.text = data.chapter.."-"..data.index;
	self.customsPassNumTxt:resetSize();
	self.customsPassNumTxt:setLocation(-347 + self.customsPassNumTxt.width, 102)
	self.customsPassTxt:setLocation(-347 + self.customsPassNumTxt.width + 4, 97, 0);
	self.fightNumTxt.text = LanUtil.formateStr(201623, data.fightNum);
end

function Lua_StarTrialLevelInfoItem:onFightBtnClick()
	if self._data.state == 0 then
		OperateAlert.show(LanUtil.getValue(201620));
		return;
	end

	self._data:recordBeforeFight();
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_STARTRIAL);
	DataCenter.preLoadData:preShowScene("Lua_StarTrialLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_StarTrialLevelInfoItem:onSceneShow(param, mp, success)
	if not success then return; end
	local data = Lua_LineupWinData.getData(Lua_FightDefine.TEMPLATE_ID_STARTRIAL, self._data.monster, self._data.id);
	Lua_WindowUtil.openWin("Lua_StarTrialLineupWindow", Lua_WinParam.ACTION_OPEN, data);
end

function Lua_StarTrialLevelInfoItem:dispose()
	if self.condIitemArr ~= nil then
		self.condIitemArr:dispose();
		self.condIitemArr:clear();
		self.condIitemArr = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	DataCenter.preLoadData:removeBySign("Lua_StarTrialLineupWindow", self, self.onSceneShow);
	self:superCall("dispose");
end










Lua_StarTrialLevelRewardItem = class("Lua_StarTrialLevelRewardItem", Lua_ListCell)
function Lua_StarTrialLevelRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_StarTrialLevelRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.66, 0.66);

	self.completeIcon = UICreate.createUIAtlasImage(self.content, "starTrial_altas", "xui_xhd_label_006", 0, 0, 97, 72);
	self.firstPassIcon = UICreate.createUIAtlasImage(self.content, "starTrial_altas", "xui_xhd_tab_01", -29, 13, 36, 66);
end

function Lua_StarTrialLevelRewardItem:setData(data)
	if data == nil then
		return;
	end

	self.itemIcon:setData(data.rewardData);
	self.itemIcon:setMask(data.state == 2);
	self.completeIcon:setEnable(data.state == 2);
	self.firstPassIcon:setEnable(data.showIcon == true);
end

function Lua_StarTrialLevelRewardItem:onPressClick()
	if self.itemIcon.data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.itemIcon.data);
end

function Lua_StarTrialLevelRewardItem:onMouseDownHandle()
	self.itemIcon:setScale(0.62, 0.62);
end

function Lua_StarTrialLevelRewardItem:onMouseUpHandle()
	self.itemIcon:setScale(0.66, 0.66);
end

function Lua_StarTrialLevelRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end