-- 星魂试炼-关卡
checkRequire("Lua_StarTrialLevelInfoItem");
Lua_StarTrialLevelPanel = class("Lua_StarTrialLevelPanel", Lua_DisplayObject);
function Lua_StarTrialLevelPanel:ctor(go)
	self:superCall("ctor", go, "StarTrialLevelPanel_skin");
end

function Lua_StarTrialLevelPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.stageItemArr = Array();
	self.rewardBoxArr = Array();

	self.starBar.typeValue = 3;
	self.starBar.fillMethodValue = 1;
	self.starBar.fillOrigin = 0;

	self.maskBg = UICreate.createImage(self.content, "/images/starTrial/xui_xhd_bj_003.png", 0, 0, 0, 0);
	self.maskBg.anchor = Lua_WindowUtil.getAnchor(1);
	self.maskBg.pivotValue = 1;
	self.maskBg.siblingIndex = 1;
	self.maskBg:setLocation(0, 360 - self.adaptHeight);

	self.dragContainer = Lua_DragContainer.new(self.content, 720, 850 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragContainer:setSiblingIndex(0);
	self.dragContainer:setRectAnchor(1);
	self.dragContainer:setRectPivot(1);
	self.dragContainer:setLocation(0, 0);

	if DataCenter.funcOpenData:isOpened(DataCenter.starRiverTrialData.constConfig.act_open_id) then
		self.trialBtn = UICreate.createUIAtlasImage(self.content, "starTrial_altas", "xui_xhd_button_008_n", 288, 406, 100, 106);
		self.trialBtn.anchor = Lua_WindowUtil.getAnchor(7);
		self.trialBtn.name = "trialBtn";
		self.trialBtn:addClickFuntion(self, self.onStarRiverTrialClick);

		self.trialRedPoint = Lua_RedPointIcon.new(self.content);
		self.trialRedPoint:setLocation(312, 434);
		self.trialRedPoint:setRectAnchor(7);
		self.trialRedPoint:createRedPointEff();
	end

	self.tipIocn:addClickFuntion(self, self.onTipIconClick);
	self.rankBtn:addClickFuntion(self, self.onRankBtnClick);
	self.sweepBtn:addClickFuntion(self, self.onSweepClick);

	self:addLuaEvent("UPDATE_STARTRIAL_INFO", self, self.updatePanel);
	self:addLuaEvent("UPDATE_STARTRIAL_STARREWARD", self, self.updateStarReward);
	self:addLuaEvent("UPDATE_STARTRIAL_DAILYREWARD", self, self.updateDailyReward);
	self:addLuaEvent("UPDATE_STARTRIAL_CHAPTER_SELECT", self, self.updateSelect);
	self:addLuaEvent("STARTRIAL_SELECT_LEVEL", self, self.buildLevelInfo);
	self:addLuaEvent("UPDATE_STARRIVER_BTN", self, self.updateStarRiverBtn);
	self:addLuaEvent("CLOSE_TRIALBTN", self, self.closeTrialBtn);
	Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sStarTrialInfo(0);
end

function Lua_StarTrialLevelPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.dragContainer:setContentRect(720, 850 + adaptHeight);
	self.maskBg:setLocation(0, 360 - adaptHeight);
end

function Lua_StarTrialLevelPanel:updatePanel()
	self:showLevel();
	self:showTips();
	self:updateStarReward();
	self:askStarRiverInfo();
end

function Lua_StarTrialLevelPanel:showLevel()
	if self.selectChapter == nil or DataCenter.starTrialData.autoRefresh then
		DataCenter.starTrialData.autoRefresh = false;
		self.isPlayTween = true;
		self.selectChapter = DataCenter.starTrialData.curChapter;
	end

	local chapterVo = DataCenter.starTrialUitl:getChapterVo(self.selectChapter);
	local stageVoArr = chapterVo.stageVoArr;
	if chapterVo.isUnlockNewStage then -- 如果解锁了新关卡那就重新定位关卡
		self.selectLevel = nil; -- 当前选中的关卡
	end

	if self.selectLevel == nil then
		if chapterVo.isMaxStar then
			self.selectLevel = chapterVo.stageVoArr:getSize(); -- 选中最后一关
		else
			for i = 1, stageVoArr:getSize() do
				if stageVoArr[i].state == 1 then -- 默认选中挑战中的
					self.selectLevel = i;
					break;
				end
				if self.selectLevel == nil and not stageVoArr[i].isMaxStar then -- 选中未满星的
					self.selectLevel = stageVoArr[i].index;
				end
			end
		end
	end

	self.dragContainer:clearList();
	self.dragContainer:addSubContainer(Lua_StarTrialStarParentItem, stageVoArr, false);
	self.dragContainer:updateChildPos();
	self.dragContainer:setSubPosition(self.dragContainer.subMaxPox);
	if self.isPlayTween == true then
		self.isPlayTween = false;
		self.dragContainer.showList[1]:playTween();
	end

	local pos = -stageVoArr[self.selectLevel].stage_pos[2];
	if pos > self.dragContainer.subMaxPox then
		pos = self.dragContainer.subMaxPox;
	elseif pos < self.dragContainer.subMinPos then
		pos = self.dragContainer.subMinPos;
	end
	self.dragContainer.moveTime = DataCenter.starTrialUitl.stageMoveTime;
	self.dragContainer:moveToTargetPos(pos);
	self.dragContainer.showList[1]:setSelect(self.selectLevel);
end

function Lua_StarTrialLevelPanel:showTips()
	local chapterVo = DataCenter.starTrialUitl:getChapterVo(self.selectChapter);
	local isShow;
	if chapterVo.nextCfg then
		local nextVo = DataCenter.starTrialUitl:getChapterVo(chapterVo.next_chapter);
		local starCond = chapterVo.starNum < nextVo.unlock_star;
		local lvCond = DataCenter.roleData.level < nextVo.limit_lvl;
		if chapterVo.isPass and (starCond or lvCond) then
			isShow = true;
			self.collectNumTxt.text = chapterVo.starNum.."/"..nextVo.unlock_star;
			self.levelNumTxt.text = nextVo.limit_lvl;
			self.collectNumTxt.colorStr = Lua_ColorDefine.transColorStr(starCond and "E55757" or "2CE654");
			self.levelNumTxt.colorStr = Lua_ColorDefine.transColorStr(lvCond and "E55757" or "2CE654");
		else
			isShow = false;
		end
	else
		isShow = false;
	end
	self.tipsBg:setEnable(isShow);
	self.tipsTxt:setEnable(isShow);
	self.collectStarTxt:setEnable(isShow);
	self.roleLevelTxt:setEnable(isShow);
	self.collectNumTxt:setEnable(isShow);
	self.levelNumTxt:setEnable(isShow);
end

function Lua_StarTrialLevelPanel:updateStarReward()
	local chapterVo = DataCenter.starTrialUitl:getChapterVo(self.selectChapter);
	self.starNumTxt.text = LanUtil.formateStr(201622, chapterVo.starNum, chapterVo.total_star);
	
	self.starBar:setMaxValue(chapterVo.total_star);
	self.starBar:setValue(chapterVo.starNum);

	local itemNum = self.rewardBoxArr:getSize();
	local voNum = #chapterVo.starRewardList;
	local showNum = itemNum > voNum and itemNum or voNum;
	local item;
	for i = 1, showNum do
		item = self.rewardBoxArr[i];
		if i > voNum then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_StarTrialRewardItem.new(self.content);
				self.rewardBoxArr:add(item);
			end
			item:setEnable(true);
			item:setRectAnchor(7);
			item:setLocation(-309, 353 + 310 * chapterVo.starRewardList[i].star_cond / chapterVo.total_star, 0);
			item:setData(chapterVo.starRewardList[i], i);
		end
	end
end

function Lua_StarTrialLevelPanel:askStarRiverInfo()
	if DataCenter.funcOpenData:isOpened(DataCenter.starRiverTrialData.constConfig.act_open_id) then
		Lua_ProxyManager.getProxy("Lua_LimitedTimeActivityProxy"):sStarRiverTrialInfo(0);
	end
end

function Lua_StarTrialLevelPanel:updateDailyReward()
	self:showSeepRed(DataCenter.starTrialData.sweepTimes ~= 0);
	self.sweepNumTxt.text = DataCenter.starTrialData.sweepTimes.."/"..DataCenter.starTrialUitl:getConstConfig("daily_times", "value");
end

function Lua_StarTrialLevelPanel:showSeepRed(val)
	if val then
		if self.sweepRedIcon == nil then
			self.sweepRedIcon = Lua_RedPointIcon.new(self.content);
			self.sweepRedIcon:setLocation(312, 313, 0);
			self.sweepRedIcon:setRectAnchor(7);
			self.sweepRedIcon:createRedPointEff();
		end
		self.sweepRedIcon:updateRedPointShow(true);
	else
		if self.sweepRedIcon ~= nil then
			self.sweepRedIcon:updateRedPointShow(false);
		end
	end
end

function Lua_StarTrialLevelPanel:updateSelect(data)
	self.selectLevel = data.level;
	self.selectChapter = data.chapter;
	self.isPlayTween = true;
	Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sStarTrialInfo(data.chapter);
end

function Lua_StarTrialLevelPanel:buildLevelInfo(data)
	if self.levelInfo == nil then
		self.levelInfo = Lua_StarTrialLevelInfoItem.new(self.content);
		self.levelInfo:setRectAnchor(7);
		self.levelInfo:setLocation(0, 163);
	end
	self.selectLevel = data.index;
	self.levelInfo:setData(data);
end

function Lua_StarTrialLevelPanel:updateStarRiverBtn(state)
	if self.trialRedPoint == nil then
		return;
	end
	self.trialRedPoint:updateRedPointShow(state);
end

function Lua_StarTrialLevelPanel:closeTrialBtn()
	if self.trialBtn ~= nil then
		self.trialBtn:setEnable(false);
	end
end

function Lua_StarTrialLevelPanel:onTipIconClick()
	local tipsData = { des = LanUtil.getValue(201602), posX = 181, posY = -237 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_StarTrialLevelPanel:onRankBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1084)
end

function Lua_StarTrialLevelPanel:onSweepClick()
	Lua_WindowUtil.openWin("Lua_StarTrialDailyRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_StarTrialLevelPanel:onStarRiverTrialClick(go)
	DataCenter.funcPathUtil:gotoFunction(DataCenter.starRiverTrialData.constConfig.event_trial_id, true)
end

function Lua_StarTrialLevelPanel:dispose()
	if self.stageItemArr ~= nil then
		self.stageItemArr:dispose();
		self.stageItemArr:clear();
		self.stageItemArr = nil;
	end
	if self.rewardBoxArr ~= nil then
		self.rewardBoxArr:dispose();
		self.rewardBoxArr:clear();
		self.rewardBoxArr = nil;
	end
	if self.sweepRedIcon ~= nil then
		self.sweepRedIcon:dispose();
		self.sweepRedIcon = nil;
	end
	if self.levelInfo ~= nil then
		self.levelInfo:dispose();
		self.levelInfo = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.trialRedPoint ~= nil then
		self.trialRedPoint:dispose();
		self.trialRedPoint = nil;
	end
	self:superCall("dispose");
end










Lua_StarTrialRewardItem = class("Lua_StarTrialRewardItem", Lua_DisplayObject);
function Lua_StarTrialRewardItem:ctor(p)
	self:superCall("ctor", p, "StarTrialRewardItem_skin");
end

function Lua_StarTrialRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.boxIcon:addClickFuntion(self, self.onBoxIconClick);
end

function Lua_StarTrialRewardItem:setData(data, index)
	self.data = data;
	if data == nil then
		return;
	end

	self.showTxt.text = data.star_cond;

	if data.state == 0 then
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_00"..index.."_n");
		self.boxIcon.alpha = 1;
	elseif data.state == 1 then
		self.boxIcon.alpha = 0.01;
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_00"..index.."_n");
	else
		self.boxIcon.alpha = 1;
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_00"..index.."_p");
	end
	self:showDrawEff(data.state == 1, index);
	self:showRedDot(data.state == 1);
end

function Lua_StarTrialRewardItem:showDrawEff(bShow, index)
	if bShow then
		if self.boxEffect == nil then
			self.boxEffect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
			self.boxEffect.siblingIndex = 0;
		end
		self.boxEffect:setUrl("/effects/uiEffects/ui_ty_xbx_0101_"..index, "ui_ty_xbx_0101_"..index);
		self.boxEffect:setEnable(false);
		self.boxEffect:setEnable(true);
	else
		if self.boxEffect ~= nil then
			self.boxEffect:setEnable(false);
		end
	end
end

function Lua_StarTrialRewardItem:showRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(25, 15, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_StarTrialRewardItem:onBoxIconClick()
	if self.data.state == 1 then
		self.boxEffect:setUrl("/effects/uiEffects/ui_ty_xbx_0101_6", "ui_ty_xbx_0101_6");
		Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sGetStarReward(self.data.chapter, self.data.id);
	else
		Lua_WindowUtil.openWin("Lua_StarTrialStarRewardWindow", Lua_WinParam.ACTION_OPEN, self.data.chapter);
	end
end

function Lua_StarTrialRewardItem:dispose()
	if self.boxEffect ~= nil then
		self.boxEffect:dispose();
		self.boxEffect = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end










Lua_StarTrialStarParentItem = class("Lua_StarTrialStarParentItem", Lua_DragContainerItem)
function Lua_StarTrialStarParentItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_StarTrialStarParentItem:buildShowItem()
	self:superCall("buildShowItem");

	self.stageItemArr = Array();
	self:addLuaEvent("STARTRIAL_SELECT_LEVEL", self, self.showSelectIcon);
end

function Lua_StarTrialStarParentItem:setData(data)
	self._data = data;

	local len = self.stageItemArr:getSize();
	local dataLen = data:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local item, curStagePos, nextStagePos, intervalX, intervalY, interval, angle;
	for i = 1, maxLen do
		item = self.stageItemArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			curStagePos = data[i].stage_pos;
			nextStagePos = data[i + 1] == nil and {0, 0} or data[i + 1].stage_pos;
			intervalX = nextStagePos[1] - curStagePos[1];
			intervalY = nextStagePos[2] - curStagePos[2];
			interval = (intervalX ^ 2 + intervalY ^ 2) ^ 0.5;
			angle = Mathf.Rad2Deg * (Mathf.Acos(intervalX / interval));

			if item == nil then
				item = Lua_StarTrialStageItem.new(self.content);
				self.stageItemArr:add(item);
			end
			item.contentName = "Lua_StarTrialStageItem_" .. i;
			item.line:SetDimensions(interval, 15);
			item.line:setRot(0, 0, angle);
			item.line:setEnable(data[i + 1] ~= nil);
			item:setSiblingIndex(1);
			item:setLocation(curStagePos[1], curStagePos[2], 0);
			item:setData(data[i]);
		end
	end
end

function Lua_StarTrialStarParentItem:playTween()
	self.showIdx = 1;
	for i = 1, self._data:getSize() do
		self.stageItemArr[i]:setEnable(false);
	end
	self:startTween();
end

function Lua_StarTrialStarParentItem:startTween()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_StarTrialStarParentItem", DataCenter.starTrialUitl.lineTime, self, self.onShowLevel);
	end
end

function Lua_StarTrialStarParentItem:onShowLevel()
	if self.showIdx >= 2 * self._data:getSize() - 1 then
		self:endTween();
	end
	
	local levelIndex = Mathf.Ceil(self.showIdx / 2)
	if self.showIdx % 2 ~= 0 then
		self.stageItemArr[levelIndex]:setEnable(true);
	else
		self.stageItemArr[levelIndex].line:setEnable(true);
	end
	self.showIdx = self.showIdx + 1;
end

function Lua_StarTrialStarParentItem:endTween()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onShowLevel);
	end
end

function Lua_StarTrialStarParentItem:setSelect(index)
	self.stageItemArr[index]:onBgClick();
end

function Lua_StarTrialStarParentItem:showSelectIcon(data)
	if self.selectIdx then
		self.stageItemArr[self.selectIdx].selectIcon:setEnable(false);
	end
	self.stageItemArr[data.index].selectIcon:setEnable(true);
	self.selectIdx = data.index;
end

function Lua_StarTrialStarParentItem:getWidth()
	return 720;
end

function Lua_StarTrialStarParentItem:getHeight()
	local levelNum = self._data:getSize();
	local minStagePosY = self._data[1].stage_pos[2] - self.stageItemArr[1]:getHeight() / 2;
	local maxStagePosY = self._data[levelNum].stage_pos[2] + self.stageItemArr[levelNum]:getHeight() / 2;
	return maxStagePosY - minStagePosY + 400;
end

function Lua_StarTrialStarParentItem:dispose()
	if self.stageItemArr ~= nil then
		self.stageItemArr:dispose();
		self.stageItemArr:clear();
		self.stageItemArr = nil;
	end
	if self._data ~= nil then
		self._data:dispose();
		self._data:clear();
		self._data = nil;
	end
	self:endTween();
	self:superCall("dispose");
end










Lua_StarTrialStageItem = class("Lua_StarTrialStageItem", Lua_DragContainerItem);
function Lua_StarTrialStageItem:ctor(p)
	self:superCall("ctor", p, "StarTrialStageItem_skin");
end

function Lua_StarTrialStageItem:buildShowItem()
	self:superCall("buildShowItem");

	self.selectIcon:setEnable(false);

	local starIcon;
	self.starArr = Array();
	for i = 1, 3 do
		starIcon = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 36, 35);
		starIcon:setLocation(-33 + (i -1) * 36, -94, 0);
		self.starArr:add(starIcon);
	end

	self.bg:addClickFuntion(self, self.onBgClick);
end

function Lua_StarTrialStageItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.showTxt.text = data.chapter .."-" ..data.index;

	local spriteName;
	for i = 1, 3 do
		spriteName = i <= data.star and "xui_xhd_label_002" or "xui_xhd_label_010";
		self.starArr[i]:setAltas("starTrial_altas", spriteName);
		self.starArr[i]:setScale(0.86, 0.86);
	end

	if data.iconType == 1 then
		self.bg:setAltas("starTrial_altas", "xui_xhd_widget_014");
		self.bg:SetDimensions(132, 108);
		self.selectIcon:setScale(0.68, 0.68);
		self.selectIcon:setLocation(4, -5);
	else
		self.bg:setAltas("starTrial_altas", "xui_xhd_widget_013");
		self.bg:SetDimensions(213, 169);
		self.selectIcon:setScale(1, 1);
		self.selectIcon:setLocation(0, 0);
	end
	self:setNewLevelTag(data.state == 1);
end

function Lua_StarTrialStageItem:setNewLevelTag(bShow)
	if bShow then
		if self.newTagIcon == nil then
			self.newTagIcon = UICreate.createUIAtlasImage(self.content, "starTrial_altas", "xui_xhd_tab_02", 30, 39, 55, 54);
		end
		self.newTagIcon:setEnable(true);
	else
		if self.newTagIcon ~= nil then
			self.newTagIcon:setEnable(false);
		end
	end
end

function Lua_StarTrialStageItem:getHeight()
	return self.selectIcon.height * self.selectIcon.scaleY;
end

function Lua_StarTrialStageItem:onBgClick()
	if self.data.limit_lvl > DataCenter.roleData.level then
		OperateAlert.show(LanUtil.formateStr(201618, tostring(self.data.limit_lvl)));
		return;
	end
	Lua_MsgUtil.callFunc("STARTRIAL_SELECT_LEVEL", self.data);
end

function Lua_StarTrialStageItem:dispose()
	if self.starArr ~= nil then
		self.starArr:dispose();
		self.starArr:clear();
		self.starArr = nil;
	end
	if self.newTagIcon ~= nil then
		self.newTagIcon:dispose();
		self.newTagIcon = nil;
	end
	self:superCall("dispose");
end