-- 星魂试炼-星数目标奖励
Lua_StarTrialStarRewardWindow = class("Lua_StarTrialStarRewardWindow", Lua_Window);
function Lua_StarTrialStarRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_StarTrialStarRewardWindow";
	self.skinName = "StarTrialStarRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_StarTrialStarRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 600, 488, Lua_AxisDefine.Vertical);
	self.dragList.tweenId = 2030;
	self.dragList:setListCell(Lua_StarTrialStarRewardItem, 600, 160, 1);
	self.dragList:setCellSpacing(0, 4);
	self.dragList:setLocation(0, -23, 0);

	self:addLuaEvent("UPDATE_REWARD_DATE", self, self.updateDdata);
end

function Lua_StarTrialStarRewardWindow:showWin(param)
	self:superCall("showWin", param);

	local chapterVo = DataCenter.starTrialUitl:getChapterVo(param);
	if chapterVo.starRewardList == nil then
		Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sStarTrialInfo(param);
	else
		self:updateDdata(chapterVo.starRewardList);
	end
end

function Lua_StarTrialStarRewardWindow:updateDdata(data)
	self.dragList:setArrayData(data);
end

function Lua_StarTrialStarRewardWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end










Lua_StarTrialStarRewardItem = class("Lua_StarTrialStarRewardItem", Lua_ListCell);
function Lua_StarTrialStarRewardItem:ctor(p)
	self:superCall("ctor", p, "StarTrialStarRewardItem_skin");
end

function Lua_StarTrialStarRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_ItemIconList.new(self.content);
	self.rewardList.scaleVal = 0.8;
	self.rewardList.pivot = 1;
	self.rewardList.canClick = true;
	self.rewardList:setRectAnchor(7);
	self.rewardList:setLocation(-231, 68, 0);

	self.showBtn:addClickFuntion(self, self.onShowBtnClick);
end

function Lua_StarTrialStarRewardItem:setData(data)
	self.data = data;

	local chapterVo = DataCenter.starTrialUitl:getChapterVo(data.chapter);
	self.chapterState = chapterVo.state;

	self.titleTxt.text = LanUtil.formateStr(201609, data.star_cond, chapterVo.starNum, data.star_cond);
	self.rewardList:setArrayData(data.reward);

	if data.state == 0 then
		self.showBtn:setLangValue(201607);
	elseif data.state == 1 then
		self.showBtn:setLangValue(201608);
	end
	self.showBtn:setEnable(data.state ~= 2);
	self.showIocn:setEnable(data.state == 2);
end

function Lua_StarTrialStarRewardItem:onShowBtnClick()
	if self.chapterState == 0 then
		OperateAlert.showLangValue(201605);
		return;
	end
	
	if self.data.state == 0 then
		Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_CHAPTER_SELECT", {chapter = self.data.chapter});
		Lua_WindowUtil.openWin("Lua_StarTrialStarRewardWindow", Lua_WinParam.ACTION_CLOSE);
	elseif self.data.state == 1 then
		Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sGetStarReward(self.data.chapter, self.data.id);
	end
end

function Lua_StarTrialStarRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end