-- 星魂试炼
checkRequire("Lua_StarTrialLevelPanel");
checkRequire("Lua_StarTrialChapterPanel")
Lua_StarTrialWindow = class("Lua_StarTrialWindow", Lua_Window);
function Lua_StarTrialWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_StarTrialWindow";
	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;
	self.isFullPaving = true;
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.showBackBtn = true;
	self.winBgPath = "/images/starTrial/xui_xhd_bj_001.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_StarTrialWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg:setLocation(0, 360 - self.adaptHeight);

	self.buttonListBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 0, 720, 121);
	self.buttonListBg.pivot = Lua_WindowUtil.getPivot(7);
	self.buttonListBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.buttonListBg.siblingIndex = 2;

	self.backBtn.siblingIndex = 3;

	self.btnInfoArr = Array();
	self.btnInfoArr:add({ textAtlas = "starTrial_altas", textNormalSprite = "xui_xhd_zgnbutton_02_n", textSelectedSprite = "xui_xhd_zgnbutton_02_p", panel = Lua_StarTrialLevelPanel, redPointId = Lua_RedPointList.StarTrial_Level});
	self.btnInfoArr:add({ textAtlas = "starTrial_altas", textNormalSprite = "xui_xhd_zgnbutton_01_n", textSelectedSprite = "xui_xhd_zgnbutton_01_p", panel = Lua_StarTrialChapterPanel, redPointId = Lua_RedPointList.StarTrial_Chapter});
	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setRectPivot(5);
	self.btnList:setLocation(360.5, 53.5, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 118, 108, 0.01, 1);
	self.btnList:setButtonItem(120, 108);
	self.btnList:setRedPoint(40, 40);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(self.btnInfoArr);
	self.btnList:setSelected(1);

	self:addLuaEvent("UPDATE_STARTRIAL_CHAPTER_SELECT", self, self.openLevelPanel);
end

function Lua_StarTrialWindow:onScreenResize()
	self:superCall("onScreenResize");
	self.winBg:setLocation(0, 360 - self.adaptHeight);
end

function Lua_StarTrialWindow:openLevelPanel()
	self.btnList:setSelected(1);
end

function Lua_StarTrialWindow:onBtnClick(index)
	local data = self.btnInfoArr[index];
	if data.panel ~= nil then
		if index == 1 then
			if self.chapterPanel ~= nil then
				self.chapterPanel:setEnable(false);
			end
			if self.levelPanel == nil then
				self.levelPanel = data.panel.new(self.content);
				self.levelPanel:setSiblingIndex(1);
				self.levelPanel:setRectAnchor(9);
			end
			self.levelPanel:setEnable(true);
		else
			if self.levelPanel ~= nil then
				self.levelPanel:setEnable(false);
			end
			if self.chapterPanel == nil then
				self.chapterPanel = data.panel.new(self.content);
				self.chapterPanel:setSiblingIndex(1);
				self.chapterPanel:setRectAnchor(9);
			end
			self.chapterPanel:setEnable(true);
		end
    end
end

function Lua_StarTrialWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1047, true);
end

function Lua_StarTrialWindow:dispose()
	if self.levelPanel ~= nil then
		self.levelPanel:dispose();
		self.levelPanel = nil;
	end
	if self.chapterPanel ~= nil then
		self.chapterPanel:dispose();
		self.chapterPanel = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.btnInfoArr ~= nil then
		self.btnInfoArr:dispose();
		self.btnInfoArr:clear();
		self.btnInfoArr = nil;
	end
	self:superCall("dispose");
end